#ifndef __SPEECH_ENGINE_H__INCLUDED__	// Protect against double 
#define __SPEECH_ENGINE_H__INCLUDED__	// inclusion of this file


// Application state macros
#define WIN32_LEAN_AND_MEAN


// Speech engine macros
#define MaxTextLength			512		// Maximum number of characters in the text buffer


// Header files
#include <windows.h>
#include <sapi.h>
#include <string.h>
#include <stdio.h>

// Speech engine classes
class SPEECH_ENGINE
{
protected:	// Data members

	ISpVoice*	Voice;							// Interface for the voice
	char		TextBuffer [ MaxTextLength ];	// Buffer for the text to be spoken

protected:	// Friendly operators

	// Intrinsic type operators
	friend SPEECH_ENGINE& operator << ( SPEECH_ENGINE& Engine, char*	Text );
	friend SPEECH_ENGINE& operator << ( SPEECH_ENGINE& Engine, int		Int );
	friend SPEECH_ENGINE& operator << ( SPEECH_ENGINE& Engine, short	Short );
	friend SPEECH_ENGINE& operator << ( SPEECH_ENGINE& Engine, long		Long );
	friend SPEECH_ENGINE& operator << ( SPEECH_ENGINE& Engine, float	Float );
	friend SPEECH_ENGINE& operator << ( SPEECH_ENGINE& Engine, double	Double );

	// Modified type operators
	friend SPEECH_ENGINE& operator << ( SPEECH_ENGINE& Engine, long double		Double );
	friend SPEECH_ENGINE& operator << ( SPEECH_ENGINE& Engine, unsigned char	Byte );
	friend SPEECH_ENGINE& operator << ( SPEECH_ENGINE& Engine, unsigned short	Short );
	friend SPEECH_ENGINE& operator << ( SPEECH_ENGINE& Engine, unsigned long	Long );

public:		// Constructor and destructor

	 SPEECH_ENGINE ();
	~SPEECH_ENGINE ();

public:		// Member functions

	void Speak			();
	void SpeakLastError ();

};

// Creates the placeholder for the instance of our speech engine
extern SPEECH_ENGINE Speech;

// NOTE:  This is done to imitate the 'cout' object, the object is actually
//	declared in the "Speech Engine Definitions.cpp" file.

#endif